# Copyright 2015 Internap.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

from functools import reduce

def group_sequences(item_list, are_in_sequence):

    def group(ranges, current):
        if len(ranges) == 0:
            ranges.append([current])
        else:
            last_range = ranges[-1]
            last_item = last_range[-1]
            if are_in_sequence(last_item, current):
                last_range.append(current)
            else:
                ranges.append([current])

        return ranges

    return reduce(group, item_list, [])
